/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDatatype;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.datatypes.CBitField;
import com.ibm.etools.c.datatypes.CChar;
import com.ibm.etools.c.datatypes.CDouble;
import com.ibm.etools.c.datatypes.CEnumeration;
import com.ibm.etools.c.datatypes.CFloat;
import com.ibm.etools.c.datatypes.CFloating;
import com.ibm.etools.c.datatypes.CInt;
import com.ibm.etools.c.datatypes.CIntegral;
import com.ibm.etools.c.datatypes.CLong;
import com.ibm.etools.c.datatypes.CLongDouble;
import com.ibm.etools.c.datatypes.CLongLong;
import com.ibm.etools.c.datatypes.CShort;
import com.ibm.etools.c.datatypes.CSignedChar;
import com.ibm.etools.c.datatypes.CUnsignedChar;
import com.ibm.etools.c.datatypes.CUnsignedInt;
import com.ibm.etools.c.datatypes.CUnsignedLong;
import com.ibm.etools.c.datatypes.CUnsignedLongLong;
import com.ibm.etools.c.datatypes.CUnsignedShort;
import com.ibm.etools.c.datatypes.CVoid;
import com.ibm.etools.c.datatypes.CWchar;
import com.ibm.etools.c.datatypes.DatatypesPackage;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangModelElement;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory </b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.datatypes.DatatypesPackage
 * @generated
 */
public class DatatypesAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static DatatypesPackage modelPackage;

    /**
     * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public DatatypesAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = DatatypesPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This implementation returns <code>true</code>
     * if the object is either the model's package or is an instance object of
     * the model. <!-- end-user-doc -->
     * 
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject) object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch the delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected DatatypesSwitch modelSwitch = new DatatypesSwitch() {
        public Object caseCLongDouble(CLongDouble object) {
            return createCLongDoubleAdapter();
        }

        public Object caseCFloating(CFloating object) {
            return createCFloatingAdapter();
        }

        public Object caseCFloat(CFloat object) {
            return createCFloatAdapter();
        }

        public Object caseCUnsignedShort(CUnsignedShort object) {
            return createCUnsignedShortAdapter();
        }

        public Object caseCDouble(CDouble object) {
            return createCDoubleAdapter();
        }

        public Object caseCShort(CShort object) {
            return createCShortAdapter();
        }

        public Object caseCUnsignedLongLong(CUnsignedLongLong object) {
            return createCUnsignedLongLongAdapter();
        }

        public Object caseCLongLong(CLongLong object) {
            return createCLongLongAdapter();
        }

        public Object caseCUnsignedLong(CUnsignedLong object) {
            return createCUnsignedLongAdapter();
        }

        public Object caseCIntegral(CIntegral object) {
            return createCIntegralAdapter();
        }

        public Object caseCLong(CLong object) {
            return createCLongAdapter();
        }

        public Object caseCUnsignedChar(CUnsignedChar object) {
            return createCUnsignedCharAdapter();
        }

        public Object caseCChar(CChar object) {
            return createCCharAdapter();
        }

        public Object caseCVoid(CVoid object) {
            return createCVoidAdapter();
        }

        public Object caseCWchar(CWchar object) {
            return createCWcharAdapter();
        }

        public Object caseCInt(CInt object) {
            return createCIntAdapter();
        }

        public Object caseCUnsignedInt(CUnsignedInt object) {
            return createCUnsignedIntAdapter();
        }

        public Object caseCBitField(CBitField object) {
            return createCBitFieldAdapter();
        }

        public Object caseCSignedChar(CSignedChar object) {
            return createCSignedCharAdapter();
        }

        public Object caseCEnumeration(CEnumeration object) {
            return createCEnumerationAdapter();
        }

        public Object caseTDLangModelElement(TDLangModelElement object) {
            return createTDLangModelElementAdapter();
        }

        public Object caseTDLangClassifier(TDLangClassifier object) {
            return createTDLangClassifierAdapter();
        }

        public Object caseCClassifier(CClassifier object) {
            return createCClassifierAdapter();
        }

        public Object caseCDerivableType(CDerivableType object) {
            return createCDerivableTypeAdapter();
        }

        public Object caseCDatatype(CDatatype object) {
            return createCDatatypeAdapter();
        }

        public Object defaultCase(EObject object) {
            return createEObjectAdapter();
        }
    };

    /**
     * Creates an adapter for the <code>target</code>. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @param target
     *            the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    public Adapter createAdapter(Notifier target) {
        return (Adapter) modelSwitch.doSwitch((EObject) target);
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CLongDouble <em>CLong Double</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CLongDouble
     * @generated
     */
    public Adapter createCLongDoubleAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CFloating <em>CFloating</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CFloating
     * @generated
     */
    public Adapter createCFloatingAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CFloat <em>CFloat</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CFloat
     * @generated
     */
    public Adapter createCFloatAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedShort <em>CUnsigned Short</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CUnsignedShort
     * @generated
     */
    public Adapter createCUnsignedShortAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CDouble <em>CDouble</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CDouble
     * @generated
     */
    public Adapter createCDoubleAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CShort <em>CShort</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CShort
     * @generated
     */
    public Adapter createCShortAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedLongLong <em>CUnsigned Long Long</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CUnsignedLongLong
     * @generated
     */
    public Adapter createCUnsignedLongLongAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CLongLong <em>CLong Long</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CLongLong
     * @generated
     */
    public Adapter createCLongLongAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedLong <em>CUnsigned Long</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CUnsignedLong
     * @generated
     */
    public Adapter createCUnsignedLongAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CIntegral <em>CIntegral</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CIntegral
     * @generated
     */
    public Adapter createCIntegralAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CLong <em>CLong</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CLong
     * @generated
     */
    public Adapter createCLongAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedChar <em>CUnsigned Char</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CUnsignedChar
     * @generated
     */
    public Adapter createCUnsignedCharAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CChar <em>CChar</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CChar
     * @generated
     */
    public Adapter createCCharAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CVoid <em>CVoid</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CVoid
     * @generated
     */
    public Adapter createCVoidAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CWchar <em>CWchar</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CWchar
     * @generated
     */
    public Adapter createCWcharAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CInt <em>CInt</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CInt
     * @generated
     */
    public Adapter createCIntAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CUnsignedInt <em>CUnsigned Int</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CUnsignedInt
     * @generated
     */
    public Adapter createCUnsignedIntAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CBitField <em>CBit Field</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CBitField
     * @generated
     */
    public Adapter createCBitFieldAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CSignedChar <em>CSigned Char</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CSignedChar
     * @generated
     */
    public Adapter createCSignedCharAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.datatypes.CEnumeration <em>CEnumeration</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.datatypes.CEnumeration
     * @generated
     */
    public Adapter createCEnumerationAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.tdlang.TDLangModelElement <em>TD Lang Model Element</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.tdlang.TDLangModelElement
     * @generated
     */
    public Adapter createTDLangModelElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.tdlang.TDLangClassifier <em>TD Lang Classifier</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.tdlang.TDLangClassifier
     * @generated
     */
    public Adapter createTDLangClassifierAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CClassifier <em>Classifier</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CClassifier
     * @generated
     */
    public Adapter createCClassifierAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CDerivableType <em>Derivable Type</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CDerivableType
     * @generated
     */
    public Adapter createCDerivableTypeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CDatatype <em>Datatype</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CDatatype
     * @generated
     */
    public Adapter createCDatatypeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case. <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} //DatatypesAdapterFactory
