/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.source.util;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.etools.c.source.CBlock;
import com.ibm.etools.c.source.CComment;
import com.ibm.etools.c.source.CStatement;
import com.ibm.etools.c.source.SourcePackage;

/**
 * <!-- begin-user-doc --> The <b>Switch </b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch doSwitch(object)}to invoke
 * the <code>caseXXX</code> method for each class of the model, starting with
 * the actual class of the object and proceeding up the inheritance hierarchy
 * until a non-null result is returned, which is the result of the switch. <!--
 * end-user-doc -->
 * 
 * @see com.ibm.etools.c.source.SourcePackage
 * @generated
 */
public class SourceSwitch {
    /**
     * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static SourcePackage modelPackage;

    /**
     * Creates an instance of the switch. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public SourceSwitch() {
        if (modelPackage == null) {
            modelPackage = SourcePackage.eINSTANCE;
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one
     * returns a non null result; it yields that result. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the first non-null result returned by a <code>caseXXX</code>
     *         call.
     * @generated
     */
    public Object doSwitch(EObject theEObject) {
        EClass theEClass = theEObject.eClass();
        if (theEClass.eContainer() == modelPackage) {
            switch (theEClass.getClassifierID()) {
            case SourcePackage.CCOMMENT: {
                CComment cComment = (CComment) theEObject;
                Object result = caseCComment(cComment);
                if (result == null)
                    result = caseCBlock(cComment);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SourcePackage.CSTATEMENT: {
                CStatement cStatement = (CStatement) theEObject;
                Object result = caseCStatement(cStatement);
                if (result == null)
                    result = caseCBlock(cStatement);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SourcePackage.CBLOCK: {
                CBlock cBlock = (CBlock) theEObject;
                Object result = caseCBlock(cBlock);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            default:
                return defaultCase(theEObject);
            }
        }
        return defaultCase(theEObject);
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CComment</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CComment</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCComment(CComment object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CStatement</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CStatement</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCStatement(CStatement object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CBlock</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CBlock</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCBlock(CBlock object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch, but this is
     * the last case anyway. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    public Object defaultCase(EObject object) {
        return null;
    }

} //SourceSwitch
